$(() => {
$('#one-section').dxDropDownButton({
text: 'Download Trial',
icon: 'save',
dropDownOptions: {
width: 230,
},
onItemClick(e) {
DevExpress.ui.notify(`Download ${e.itemData}`, 'success', 600);
},
items: downloads,
});
$('#two-sections').dxDropDownButton({
items: profileSettings,
splitButton: true,
onButtonClick(e) {
DevExpress.ui.notify(`Go to ${e.component.option('text')}'s profile`, 'success', 600);
},
onItemClick(e) {
DevExpress.ui.notify(e.itemData.name, 'success', 600);
},
text: 'Sandra Johnson',
icon: '../../../../images/gym/coach-woman.png',
displayExpr: 'name',
keyExpr: 'id',
useSelectMode: false,
});
$('#template').dxToolbar({
items: [
{
location: 'before',
widget: 'dxDropDownButton',
options: {
displayExpr: 'name',
keyExpr: 'id',
selectedItemKey: 3,
width: 125,
stylingMode: 'text',
useSelectMode: true,
onSelectionChanged(e) {
$('#text').css('text-align', e.item.name.toLowerCase());
},
items: alignments,
},
},
{
location: 'before',
widget: 'dxDropDownButton',
options: {
items: colors,
icon: 'square',
stylingMode: 'text',
dropDownOptions: { width: 'auto' },
onInitialized(e) {
dropDownButton = e.component;
},
dropDownContentTemplate(data, $container) {
const $colorPicker = $('<div>')
.addClass('custom-color-picker')
.appendTo($container);
data.forEach((color) => {
const $button = $('<i>')
.addClass('color dx-icon dx-icon-square')
.on('dxclick', () => {
applyColor($('#text'), color);
applyColor(dropDownButton.$element().find('.dx-dropdownbutton-action .dx-icon').first(), color);
dropDownButton.close();
});
applyColor($button, color);
$colorPicker.append($button);
});
},
},
},
{
location: 'before',
widget: 'dxDropDownButton',
options: {
stylingMode: 'text',
displayExpr: 'text',
keyExpr: 'size',
useSelectMode: true,
items: fontSizes,
selectedItemKey: 14,
onSelectionChanged(e) {
$('#text').css('font-size', `${e.item.size}px`);
},
itemTemplate(itemData) {
return $('<div>')
.text(itemData.text)
.css('font-size', `${itemData.size}px`);
},
},
},
{
location: 'before',
widget: 'dxDropDownButton',
options: {
stylingMode: 'text',
icon: 'indent',
displayExpr: 'text',
keyExpr: 'lineHeight',
useSelectMode: true,
items: lineHeights,
selectedItemKey: 1.35,
onSelectionChanged(e) {
$('#text').css('line-height', e.item.lineHeight);
},
},
},
],
});
});
let dropDownButton;
function applyColor($element, color) {
if (color) {
$element.removeClass('dx-theme-text-color');
$element.css('color', color);
} else {
$element.addClass('dx-theme-text-color');
}
}
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/21.2.7/js/dx.all.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="data.js"></script>
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="dx-fieldset">
<div class="dx-fieldset-header">Single usage</div>
<div class="dx-field">
<div class="dx-field-label"> Custom static text </div>
<div class="dx-field-value">
<div id="one-section"></div>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label"> Custom main button action </div>
<div class="dx-field-value">
<div id="two-sections"></div>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Usage in a toolbar</div>
<div class="dx-field">
<div id="template"></div>
</div>
<div class="dx-field">
<p id="text"
>Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco
laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat
non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p
>
</div>
</div>
</div>
</body>
</html>
.demo-container .dx-fieldset:first-child {
width: 500px;
}
.custom-color-picker {
width: 82px;
padding: 5px;
}
.dx-button-content img.dx-icon {
width: 24px;
height: 24px;
}
.color {
cursor: pointer;
font-size: 18px;
}
#text {
line-height: 1.35;
}
const colors = [null, '#980000', '#ff0000', '#ff9900', '#ffff00', '#00ff00', '#00ffff', '#4a86e8', '#0000ff', '#9900ff', '#ff00ff', '#ff3466'];
const profileSettings = [
{ id: 1, name: 'Profile', icon: 'user' },
{
id: 4, name: 'Messages', icon: 'email', badge: '5',
},
{ id: 2, name: 'Friends', icon: 'group' },
{ id: 3, name: 'Exit', icon: 'runner' },
];
const downloads = ['Download Trial For Visual Studio', 'Download Trial For All Platforms', 'Package Managers'];
const alignments = [
{ id: 1, name: 'Left', icon: 'alignleft' },
{ id: 4, name: 'Right', icon: 'alignright' },
{ id: 2, name: 'Center', icon: 'aligncenter' },
{ id: 3, name: 'Justify', icon: 'alignjustify' },
];
const fontSizes = [
{ size: 10, text: '10px' },
{ size: 12, text: '12px' },
{ size: 14, text: '14px' },
{ size: 16, text: '16px' },
{ size: 18, text: '18px' },
];
const lineHeights = [
{ lineHeight: 1, text: '1' },
{ lineHeight: 1.35, text: '1.35' },
{ lineHeight: 1.5, text: '1.5' },
{ lineHeight: 2, text: '2' },
];

<div class="dx-fieldset">
<div class="dx-fieldset-header">Single usage</div>
<div class="dx-field">
<div class="dx-field-label"> Custom static text </div>
<div class="dx-field-value">
<dx-drop-down-button
text="Download Trial"
[dropDownOptions]="{ width: 230 }"
icon="save"
[items]="downloads"
(onItemClick)="onItemClick($event)"
></dx-drop-down-button>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label"> Custom main button action </div>
<div class="dx-field-value">
<dx-drop-down-button
[splitButton]="true"
[useSelectMode]="false"
text="Sandra Johnson"
icon="../../../../images/gym/coach-woman.png"
[items]="profileSettings"
displayExpr="name"
keyExpr="id"
(onButtonClick)="onButtonClick($event)"
(onItemClick)="onItemClick($event)"
></dx-drop-down-button>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Usage in a toolbar</div>
<div class="dx-field">
<dx-toolbar>
<dxi-item
location="before"
widget="dxDropDownButton"
[options]="{
items: alignments,
displayExpr: 'name',
keyExpr: 'value',
selectedItemKey: 'justify',
width: 125,
stylingMode: 'text',
useSelectMode: true,
onSelectionChanged: onAlignmentChanged
}"
>
</dxi-item>
<dxi-item
location="before"
widget="dxDropDownButton"
[options]="{
onInitialized: onColorPickerInit,
items: colors,
icon: 'square',
stylingMode: 'text',
dropDownOptions: { width: 'auto' },
dropDownContentTemplate: 'colorpicker'
}"
>
</dxi-item>
<dxi-item
location="before"
widget="dxDropDownButton"
[options]="{
stylingMode: 'text',
displayExpr: 'name',
keyExpr: 'value',
useSelectMode: true,
items: fontSizes,
selectedItemKey: 14,
onSelectionChanged: onFontSizeChanged,
itemTemplate: 'fontItem'
}"
>
</dxi-item>
<dxi-item
location="before"
widget="dxDropDownButton"
[options]="{
stylingMode: 'text',
icon: 'indent',
displayExpr: 'name',
keyExpr: 'value',
useSelectMode: true,
items: lineHeights,
selectedItemKey: 1.35,
onSelectionChanged: onLineHeightChanged
}"
>
</dxi-item>
<div
*dxTemplate="let data of 'fontItem'"
[style.fontSize]="data.value + 'px'"
>
{{ data.name }}
</div>
<div *dxTemplate="let data of 'colorpicker'">
<div class="custom-color-picker">
<i
*ngFor="let iconColor of colors"
class="color dx-icon dx-icon-square"
[ngClass]="{ 'dx-theme-text-color': !iconColor }"
[style.color]="iconColor"
(click)="onColorClick(iconColor)"
></i>
</div>
</div>
</dx-toolbar>
</div>
<div class="dx-field">
<p
id="text"
[style.fontSize]="fontSize + 'px'"
[style.lineHeight]="lineHeight"
[style.color]="color"
[style.textAlign]="alignment"
>Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod
tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim
veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea
commodo consequat. Duis aute irure dolor in reprehenderit in voluptate
velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat
cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id
est laborum.</p
>
</div>
</div>
import {
NgModule, Component, ViewChild, enableProdMode,
} from '@angular/core';
import { BrowserModule, BrowserTransferStateModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import notify from 'devextreme/ui/notify';
import {
DxDropDownButtonModule,
DxToolbarModule,
} from 'devextreme-angular';
import { SimpleObject, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service],
})
export class AppComponent {
fontSize: number;
color: string;
lineHeight: number;
alignment: string;
dropDownButton: any;
colors: string[];
downloads: string[];
profileSettings: SimpleObject[];
fontSizes: SimpleObject[];
lineHeights: SimpleObject[];
alignments: SimpleObject[];
constructor(service: Service) {
this.fontSize = 14;
this.color = null;
this.lineHeight = 1.35;
this.alignment = 'left';
this.colors = service.getColors();
this.fontSizes = service.getFontSizes();
this.downloads = service.getDownloads();
this.profileSettings = service.getProfileSettings();
this.alignments = service.getAlignments();
this.lineHeights = service.getLineHeights();
}
onAlignmentChanged = (e) => {
this.alignment = e.item.value;
};
onFontSizeChanged = (e) => {
this.fontSize = e.item.value;
};
onLineHeightChanged = (e) => {
this.lineHeight = e.item.value;
};
onButtonClick(e) {
notify(`Go to ${e.component.option('text')}'s profile`, 'success', 600);
}
onItemClick(e) {
notify(e.itemData.name || e.itemData, 'success', 600);
}
onColorPickerInit = (e) => {
this.dropDownButton = e.component;
};
onColorClick(color) {
this.color = color;
this.dropDownButton.element().getElementsByClassName('dx-icon-square')[0].style.color = color;
this.dropDownButton.close();
}
}
@NgModule({
imports: [
BrowserModule,
BrowserTransferStateModule,
DxDropDownButtonModule,
DxToolbarModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep .demo-container .dx-fieldset:first-child {
width: 500px;
}
::ng-deep .custom-color-picker {
width: 82px;
padding: 5px;
}
::ng-deep .dx-button-content img.dx-icon {
width: 24px;
height: 24px;
}
::ng-deep .color {
cursor: pointer;
font-size: 18px;
}
import { Injectable } from '@angular/core';
export class SimpleObject {
value: number | string;
name: string;
icon?: string;
badge?: string;
}
const colors = [null, '#980000', '#ff0000', '#ff9900', '#ffff00', '#00ff00', '#00ffff', '#4a86e8', '#0000ff', '#9900ff', '#ff00ff', '#ff3466'];
const profileSettings: SimpleObject[] = [
{ value: 1, name: 'Profile', icon: 'user' },
{
value: 4, name: 'Messages', icon: 'email', badge: '5',
},
{ value: 2, name: 'Friends', icon: 'group' },
{ value: 3, name: 'Exit', icon: 'runner' },
];
const downloads = ['Download Trial For Visual Studio', 'Download Trial For All Platforms', 'Package Managers'];
const alignments: SimpleObject[] = [
{ value: 'left', name: 'Left', icon: 'alignleft' },
{ value: 'right', name: 'Right', icon: 'alignright' },
{ value: 'center', name: 'Center', icon: 'aligncenter' },
{ value: 'justify', name: 'Justify', icon: 'alignjustify' },
];
const fontSizes: SimpleObject[] = [
{ value: 10, name: '10px' },
{ value: 12, name: '12px' },
{ value: 14, name: '14px' },
{ value: 16, name: '16px' },
{ value: 18, name: '18px' },
];
const lineHeights: SimpleObject[] = [
{ value: 1, name: '1' },
{ value: 1.35, name: '1.35' },
{ value: 1.5, name: '1.5' },
{ value: 2, name: '2' },
];
@Injectable()
export class Service {
getColors(): string[] {
return colors;
}
getDownloads(): string[] {
return downloads;
}
getAlignments(): SimpleObject[] {
return alignments;
}
getProfileSettings(): SimpleObject[] {
return profileSettings;
}
getFontSizes(): SimpleObject[] {
return fontSizes;
}
getLineHeights(): SimpleObject[] {
return lineHeights;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.17',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17',
'@angular/forms': 'npm:@angular/forms@12.2.17',
'@angular/common': 'npm:@angular/common@12.2.17',
'@angular/compiler': 'npm:@angular/compiler@12.2.17',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.5/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@23.1.5/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.1',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.48',
'devextreme-angular': 'npm:devextreme-angular@23.1.5',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.11',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.11/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.17/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@23.1.5/*/package.json',
'npm:devextreme-angular@23.1.5/ui/*/package.json',
'npm:devextreme-angular@23.1.5/package.json',
'npm:devexpress-diagram@2.2.1/package.json',
'npm:devexpress-gantt@4.1.48/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

import React from 'react';
import DropDownButton from 'devextreme-react/drop-down-button';
import Toolbar from 'devextreme-react/toolbar';
import { Template } from 'devextreme-react/core/template';
import notify from 'devextreme/ui/notify';
import service from './data.js';
import ColorIcon from './ColorIcon.js';
import 'whatwg-fetch';
const buttonDropDownOptions = { width: 230 };
class App extends React.Component {
onButtonClick(e) {
notify(`Go to ${e.component.option('text')}'s profile`, 'success', 600);
}
onItemClick(e) {
notify(e.itemData.name || e.itemData, 'success', 600);
}
onColorClick(color) {
this.setState({
color,
});
this.colorPicker.element().getElementsByClassName('dx-icon-square')[0].style.color = color;
this.colorPicker.close();
}
itemTemplateRender(item) {
return (<div style={{ fontSize: `${item.size}px` }}>
{item.text}
</div>);
}
constructor(props) {
super(props);
this.onColorClick = this.onColorClick.bind(this);
this.data = service.getData();
this.state = {
alignment: 'left',
color: null,
fontSize: 14,
lineHeight: 1.35,
};
this.toolbarItems = [
{
location: 'before',
widget: 'dxDropDownButton',
options: {
displayExpr: 'name',
keyExpr: 'id',
selectedItemKey: 3,
width: 125,
stylingMode: 'text',
useSelectMode: true,
onSelectionChanged: (e) => {
this.setState({
alignment: e.item.name.toLowerCase(),
});
},
items: this.data.alignments,
},
},
{
location: 'before',
widget: 'dxDropDownButton',
options: {
items: this.data.colors,
icon: 'square',
stylingMode: 'text',
dropDownOptions: { width: 'auto' },
onInitialized: ({ component }) => {
this.colorPicker = component;
},
dropDownContentTemplate: 'colorpicker',
},
},
{
location: 'before',
widget: 'dxDropDownButton',
options: {
stylingMode: 'text',
displayExpr: 'text',
keyExpr: 'size',
useSelectMode: true,
items: this.data.fontSizes,
selectedItemKey: 14,
onSelectionChanged: (e) => {
this.setState({
fontSize: e.item.size,
});
},
itemTemplate: 'fontItem',
},
},
{
location: 'before',
widget: 'dxDropDownButton',
options: {
stylingMode: 'text',
icon: 'indent',
displayExpr: 'text',
keyExpr: 'lineHeight',
useSelectMode: true,
items: this.data.lineHeights,
selectedItemKey: 1.35,
onSelectionChanged: (e) => {
this.setState({
lineHeight: e.item.lineHeight,
});
},
},
},
];
}
render() {
return (
<div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Single usage</div>
<div className="dx-field">
<div className="dx-field-label">
Custom static text
</div>
<div className="dx-field-value">
<DropDownButton
text="Download Trial"
icon="save"
dropDownOptions={buttonDropDownOptions}
items={this.data.downloads}
onItemClick={this.onItemClick}
/>
</div>
</div>
<div className="dx-field">
<div className="dx-field-label">
Custom main button action
</div>
<div className="dx-field-value">
<DropDownButton
splitButton={true}
useSelectMode={false}
text="Sandra Johnson"
icon="../../../../images/gym/coach-woman.png"
items={this.data.profileSettings}
displayExpr="name"
keyExpr="id"
onButtonClick={this.onButtonClick}
onItemClick={this.onItemClick}
/>
</div>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">Usage in a toolbar</div>
<div className="dx-field">
<Toolbar items={this.toolbarItems}>
<Template name="colorpicker">
<div className="custom-color-picker">
{this.data.colors.map((color, i) => (
<ColorIcon key={i} color={color} onClick={this.onColorClick} />
))}
</div>
</Template>
<Template name="fontItem" render={ this.itemTemplateRender }>
</Template>
</Toolbar>
</div>
<div className={ this.state.color ? 'dx-field' : 'dx-field dx-theme-text-color' } style={{
color: this.state.color,
textAlign: this.state.alignment,
lineHeight: this.state.lineHeight,
fontSize: `${this.state.fontSize}px`,
}}>
<p id="text">Lorem ipsum dolor sit amet, consectetur adipiscing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur. Excepteur sint occaecat cupidatat non proident, sunt in culpa qui officia deserunt mollit anim id est laborum.</p>
</div>
</div>
</div>
);
}
}
export default App;
import React from 'react';
class ColorIcon extends React.Component {
constructor(props) {
super(props);
this.onClick = this.onClick.bind(this);
}
onClick() {
this.props.onClick(this.props.color);
}
render() {
return (
<i
onClick={this.onClick}
className={this.props.color ? 'color dx-icon dx-icon-square' : 'color dx-icon dx-icon-square dx-theme-text-color'}
style={{ color: this.props.color }}
/>
);
}
}
export default ColorIcon;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.3/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.demo-container .dx-fieldset:first-child {
width: 500px;
}
.custom-color-picker {
width: 82px;
padding: 5px;
}
.dx-button-content img.dx-icon {
width: 24px;
height: 24px;
}
.color {
cursor: pointer;
font-size: 18px;
}
const colors = [null, '#980000', '#ff0000', '#ff9900', '#ffff00', '#00ff00', '#00ffff', '#4a86e8', '#0000ff', '#9900ff', '#ff00ff', '#ff3466'];
const profileSettings = [
{ id: 1, name: 'Profile', icon: 'user' },
{
id: 4, name: 'Messages', icon: 'email', badge: '5',
},
{ id: 2, name: 'Friends', icon: 'group' },
{ id: 3, name: 'Exit', icon: 'runner' },
];
const downloads = ['Download Trial For Visual Studio', 'Download Trial For All Platforms', 'Package Managers'];
const alignments = [
{ id: 1, name: 'Left', icon: 'alignleft' },
{ id: 4, name: 'Right', icon: 'alignright' },
{ id: 2, name: 'Center', icon: 'aligncenter' },
{ id: 3, name: 'Justify', icon: 'alignjustify' },
];
const fontSizes = [
{ size: 10, text: '10px' },
{ size: 12, text: '12px' },
{ size: 14, text: '14px' },
{ size: 16, text: '16px' },
{ size: 18, text: '18px' },
];
const lineHeights = [
{ lineHeight: 1, text: '1' },
{ lineHeight: 1.35, text: '1.35' },
{ lineHeight: 1.5, text: '1.5' },
{ lineHeight: 2, text: '2' },
];
export default {
getData() {
return {
colors, profileSettings, downloads, alignments, fontSizes, lineHeights,
};
},
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.1.3/cjs',
'devextreme-react': 'npm:devextreme-react@22.1.3',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.16/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.57/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.30/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.7',
'inferno': 'npm:inferno@7.4.4/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.7/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

<template>
<div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Single usage</div>
<div class="dx-field">
<div class="dx-field-label">
Custom static text
</div>
<div class="dx-field-value">
<DxDropDownButton
:items="data.downloads"
:drop-down-options="{ width: 230 }"
text="Download Trial"
icon="save"
@item-click="onItemClick"
/>
</div>
</div>
<div class="dx-field">
<div class="dx-field-label">
Custom main button action
</div>
<div class="dx-field-value">
<DxDropDownButton
:split-button="true"
:use-select-mode="false"
:items="data.profileSettings"
text="Sandra Johnson"
icon="../../../../images/gym/coach-woman.png"
display-expr="name"
key-expr="id"
@button-click="onButtonClick"
@item-click="onItemClick"
/>
</div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">Usage in a toolbar</div>
<div class="dx-field">
<DxToolbar :items="toolbarItems">
<template #fontItem="{ data }">
<div :style="{ fontSize: data.size + 'px'}">
{{ data.text }}
</div>
</template>
<template #colorpicker="{ data }">
<div class="custom-color-picker">
<i
v-for="(itemColor, i) in data"
:key="i"
:class="itemColor ?
'color dx-icon dx-icon-square' :
'color dx-icon dx-icon-square dx-theme-text-color'"
:style="{ color: itemColor }"
@click="onColorClick(itemColor)"
/>
</div>
</template>
</DxToolbar>
</div>
<div class="dx-field">
<p
id="text"
:style="{
textAlign: alignment,
fontSize: fontSize,
color: color,
lineHeight: lineHeight
}"
>Lorem ipsum dolor sit amet, consectetur adipiscing elit,
sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.
Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris
nisi ut aliquip ex ea commodo consequat. Duis aute irure dolor in
reprehenderit in voluptate velit esse cillum dolore eu fugiat nulla pariatur.
Excepteur sint occaecat cupidatat non proident,
sunt in culpa qui officia deserunt mollit anim id est laborum.</p>
</div>
</div>
</div>
</template>
<script>
import DxDropDownButton from 'devextreme-vue/drop-down-button';
import DxToolbar from 'devextreme-vue/toolbar';
import notify from 'devextreme/ui/notify';
import service from './data.js';
import 'whatwg-fetch';
export default {
components: {
DxDropDownButton,
DxToolbar,
},
data() {
const data = service.getData();
return {
data,
alignment: 'left',
color: null,
fontSize: '14px',
lineHeight: 1.35,
toolbarItems: [
{
location: 'before',
widget: 'dxDropDownButton',
options: {
displayExpr: 'name',
keyExpr: 'id',
selectedItemKey: 3,
width: 125,
stylingMode: 'text',
useSelectMode: true,
onSelectionChanged: (e) => {
this.alignment = e.item.name.toLowerCase();
},
items: data.alignments,
},
},
{
location: 'before',
widget: 'dxDropDownButton',
options: {
items: data.colors,
onInitialized: ({ component }) => {
this.colorPicker = component;
},
icon: 'square',
stylingMode: 'text',
dropDownOptions: { width: 'auto' },
dropDownContentTemplate: 'colorpicker',
},
},
{
location: 'before',
widget: 'dxDropDownButton',
options: {
stylingMode: 'text',
displayExpr: 'text',
keyExpr: 'size',
useSelectMode: true,
items: data.fontSizes,
selectedItemKey: 14,
onSelectionChanged: (e) => {
this.fontSize = `${e.item.size}px`;
},
itemTemplate: 'fontItem',
},
},
{
location: 'before',
widget: 'dxDropDownButton',
options: {
stylingMode: 'text',
icon: 'indent',
displayExpr: 'text',
keyExpr: 'lineHeight',
useSelectMode: true,
items: data.lineHeights,
selectedItemKey: 1.35,
onSelectionChanged: (e) => {
this.lineHeight = e.item.lineHeight;
},
},
},
],
};
},
methods: {
onButtonClick(e) {
notify(`Go to ${e.component.option('text')}'s profile`, 'success', 600);
},
onItemClick(e) {
notify(e.itemData.name || e.itemData, 'success', 600);
},
onColorClick(color) {
this.color = color;
this.colorPicker.element().getElementsByClassName('dx-icon-square')[0].style.color = color;
this.colorPicker.close();
},
},
};
</script>
<style scoped>
.demo-container .dx-fieldset:first-child {
width: 500px;
}
.dx-popup-content > .dx-template-wrapper.custom-color-picker {
width: 82px;
padding: 5px;
}
.dx-button-content img.dx-icon {
width: 24px;
height: 24px;
}
.color {
cursor: pointer;
font-size: 18px;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/21.2.7/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
const colors = [null, '#980000', '#ff0000', '#ff9900', '#ffff00', '#00ff00', '#00ffff', '#4a86e8', '#0000ff', '#9900ff', '#ff00ff', '#ff3466'];
const profileSettings = [
{ id: 1, name: 'Profile', icon: 'user' },
{
id: 4, name: 'Messages', icon: 'email', badge: '5',
},
{ id: 2, name: 'Friends', icon: 'group' },
{ id: 3, name: 'Exit', icon: 'runner' },
];
const downloads = ['Download Trial For Visual Studio', 'Download Trial For All Platforms', 'Package Managers'];
const alignments = [
{ id: 1, name: 'Left', icon: 'alignleft' },
{ id: 4, name: 'Right', icon: 'alignright' },
{ id: 2, name: 'Center', icon: 'aligncenter' },
{ id: 3, name: 'Justify', icon: 'alignjustify' },
];
const fontSizes = [
{ size: 10, text: '10px' },
{ size: 12, text: '12px' },
{ size: 14, text: '14px' },
{ size: 16, text: '16px' },
{ size: 18, text: '18px' },
];
const lineHeights = [
{ lineHeight: 1, text: '1' },
{ lineHeight: 1.35, text: '1.35' },
{ lineHeight: 1.5, text: '1.5' },
{ lineHeight: 2, text: '2' },
];
export default {
getData() {
return {
colors, profileSettings, downloads, alignments, fontSizes, lineHeights,
};
},
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'whatwg-fetch': 'npm:whatwg-fetch@3.6.2/fetch.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@21.2.7/cjs',
'devextreme-vue': 'npm:devextreme-vue@21.2.7',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.14/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.47/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.0.13/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@2.3.14',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@2.3.14/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);